
//
// Academic License - for use in teaching, academic research, and meeting
// course requirements at degree granting institutions only.  Not for
// government, commercial, or other organizational use.
// File: kin_xyzbc_tt_J2P_tj.cpp
//
// MATLAB Coder version            : 5.4
//

// Include Files
#include "kin_xyzbc_tt_J2P_tj.h"
#include "coder_array.h"
#include <cmath>

// Function Definitions
//
// function J2P_tj = kin_xyzbc_tt_J2P_tj(in1,in2,in3,in4)
//
// kin_xyzbc_tt_J2P_tj
//     J2P_tj = kin_xyzbc_tt_J2P_tj(IN1,IN2,IN3,IN4)
//
// Arguments    : const ::coder::array<double, 1U> &in1
//                const ::coder::array<double, 1U> &in2
//                const ::coder::array<double, 1U> &in3
//                const ::coder::array<double, 1U> &in4
//                double J2P_tj[5][5]
// Return Type  : void
//
namespace ocn {
void kin_xyzbc_tt_J2P_tj(const ::coder::array<double, 1U> &in1,
                         const ::coder::array<double, 1U> &in2,
                         const ::coder::array<double, 1U> &in3,
                         const ::coder::array<double, 1U> &in4, double J2P_tj[5][5])
{
    double b_in2[25];
    double b_in2_tmp;
    double b_t58_tmp;
    double c_in2_tmp;
    double d_in2_tmp;
    double e_in2_tmp;
    double f_in2_tmp;
    double g_in2_tmp;
    double in2_tmp;
    double t15;
    double t15_tmp;
    double t17;
    double t17_tmp;
    double t19;
    double t2;
    double t22;
    double t23;
    double t24;
    double t28;
    double t29;
    double t3;
    double t36;
    double t37;
    double t38;
    double t4;
    double t41;
    double t42;
    double t42_tmp;
    double t45;
    double t45_tmp;
    double t5;
    double t50;
    double t50_tmp;
    double t52;
    double t53;
    double t57;
    double t58;
    double t58_tmp;
    double t59;
    double t6;
    double t61;
    double t62;
    double t63;
    double t7;
    double t70;
    double t71;
    double t72;
    double t72_tmp;
    double t73;
    double t73_tmp;
    //     This function was generated by the Symbolic Math Toolbox version 9.1.
    //     07-Nov-2023 14:54:38
    // Jacobian second derivative ( Forward Kinematics ) :
    // INPUTS :
    // 	r_j    (5x1) : pose vector( joint space )
    // 	v_j    (5x1) : speed vector( joint space )
    // 	a_j    (5x1) : acceleration vector( joint space )
    // 	j_j    (5x1) : jerk vector( joint space )
    // 	p      (3x5) : parameters
    // OUTPUTS :
    // 	M      (5x5) : resulting matrix
    // 'kin_xyzbc_tt_J2P_tj:18' b = in1(4,:);
    // 'kin_xyzbc_tt_J2P_tj:19' c = in1(5,:);
    // 'kin_xyzbc_tt_J2P_tj:20' jp1 = in2(1,:);
    // 'kin_xyzbc_tt_J2P_tj:21' jp2 = in2(2,:);
    // 'kin_xyzbc_tt_J2P_tj:22' jp3 = in2(3,:);
    // 'kin_xyzbc_tt_J2P_tj:23' jp4 = in2(4,:);
    // 'kin_xyzbc_tt_J2P_tj:24' jp5 = in2(5,:);
    // 'kin_xyzbc_tt_J2P_tj:25' jpp1 = in3(1,:);
    // 'kin_xyzbc_tt_J2P_tj:26' jpp2 = in3(2,:);
    // 'kin_xyzbc_tt_J2P_tj:27' jpp3 = in3(3,:);
    // 'kin_xyzbc_tt_J2P_tj:28' jpp4 = in3(4,:);
    // 'kin_xyzbc_tt_J2P_tj:29' jpp5 = in3(5,:);
    // 'kin_xyzbc_tt_J2P_tj:30' offB1 = in4(10);
    // 'kin_xyzbc_tt_J2P_tj:31' offB2 = in4(11);
    // 'kin_xyzbc_tt_J2P_tj:32' offC1 = in4(13);
    // 'kin_xyzbc_tt_J2P_tj:33' offB3 = in4(12);
    // 'kin_xyzbc_tt_J2P_tj:34' offC2 = in4(14);
    // 'kin_xyzbc_tt_J2P_tj:35' offC3 = in4(15);
    // 'kin_xyzbc_tt_J2P_tj:36' offM1 = in4(1);
    // 'kin_xyzbc_tt_J2P_tj:37' offM2 = in4(2);
    // 'kin_xyzbc_tt_J2P_tj:38' offM3 = in4(3);
    // 'kin_xyzbc_tt_J2P_tj:39' offT1 = in4(4);
    // 'kin_xyzbc_tt_J2P_tj:40' offT2 = in4(5);
    // 'kin_xyzbc_tt_J2P_tj:41' offT3 = in4(6);
    // 'kin_xyzbc_tt_J2P_tj:42' x = in1(1,:);
    // 'kin_xyzbc_tt_J2P_tj:43' y = in1(2,:);
    // 'kin_xyzbc_tt_J2P_tj:44' z = in1(3,:);
    // 'kin_xyzbc_tt_J2P_tj:45' t2 = cos(b);
    t2 = std::cos(in1[3]);
    // 'kin_xyzbc_tt_J2P_tj:46' t3 = cos(c);
    t3 = std::cos(in1[4]);
    // 'kin_xyzbc_tt_J2P_tj:47' t4 = sin(b);
    t4 = std::sin(in1[3]);
    // 'kin_xyzbc_tt_J2P_tj:48' t5 = sin(c);
    t5 = std::sin(in1[4]);
    // 'kin_xyzbc_tt_J2P_tj:49' t6 = jp4.^2;
    t6 = in2[3] * in2[3];
    // 'kin_xyzbc_tt_J2P_tj:50' t7 = jp5.^2;
    t7 = in2[4] * in2[4];
    // 'kin_xyzbc_tt_J2P_tj:51' t12 = -offM1;
    // 'kin_xyzbc_tt_J2P_tj:52' t13 = -offM2;
    // 'kin_xyzbc_tt_J2P_tj:53' t14 = -offM3;
    // 'kin_xyzbc_tt_J2P_tj:54' t8 = offB1.*t3;
    // 'kin_xyzbc_tt_J2P_tj:55' t9 = offB2.*t3;
    // 'kin_xyzbc_tt_J2P_tj:56' t10 = offB1.*t5;
    // 'kin_xyzbc_tt_J2P_tj:57' t11 = offB2.*t5;
    // 'kin_xyzbc_tt_J2P_tj:58' t15 = jp1.*t2.*t3;
    t15_tmp = in2[0] * t2;
    t15 = t15_tmp * t3;
    // 'kin_xyzbc_tt_J2P_tj:59' t16 = jp3.*t2.*t3;
    // 'kin_xyzbc_tt_J2P_tj:60' t17 = jp4.*t2.*t3;
    t17_tmp = in2[3] * t2;
    t17 = t17_tmp * t3;
    // 'kin_xyzbc_tt_J2P_tj:61' t18 = jp5.*t2.*t3;
    // 'kin_xyzbc_tt_J2P_tj:62' t19 = jp1.*t2.*t5;
    t19 = t15_tmp * t5;
    // 'kin_xyzbc_tt_J2P_tj:63' t20 = jp1.*t3.*t4;
    // 'kin_xyzbc_tt_J2P_tj:64' t21 = jp3.*t2.*t5;
    // 'kin_xyzbc_tt_J2P_tj:65' t22 = jp3.*t3.*t4;
    t22 = in2[2] * t3 * t4;
    // 'kin_xyzbc_tt_J2P_tj:66' t23 = jp4.*t2.*t5;
    t23 = t17_tmp * t5;
    // 'kin_xyzbc_tt_J2P_tj:67' t24 = jp4.*t3.*t4;
    t24 = in2[3] * t3 * t4;
    // 'kin_xyzbc_tt_J2P_tj:68' t25 = jp5.*t2.*t5;
    // 'kin_xyzbc_tt_J2P_tj:69' t26 = jp5.*t3.*t4;
    // 'kin_xyzbc_tt_J2P_tj:70' t27 = jp1.*t4.*t5;
    // 'kin_xyzbc_tt_J2P_tj:71' t28 = jp3.*t4.*t5;
    t28 = in2[2] * t4 * t5;
    // 'kin_xyzbc_tt_J2P_tj:72' t29 = jp4.*t4.*t5;
    t29 = in2[3] * t4 * t5;
    // 'kin_xyzbc_tt_J2P_tj:73' t30 = jp5.*t4.*t5;
    // 'kin_xyzbc_tt_J2P_tj:74' t36 = offB1+offC1+offT1+t12+x;
    t36 = (((in4[9] + in4[12]) + in4[3]) + -in4[0]) + in1[0];
    // 'kin_xyzbc_tt_J2P_tj:75' t37 = offB2+offC2+offT2+t13+y;
    t37 = (((in4[10] + in4[13]) + in4[4]) + -in4[1]) + in1[1];
    // 'kin_xyzbc_tt_J2P_tj:76' t38 = offB3+offC3+offT3+t14+z;
    t38 = (((in4[11] + in4[14]) + in4[5]) + -in4[2]) + in1[2];
    // 'kin_xyzbc_tt_J2P_tj:77' t31 = -t9;
    // 'kin_xyzbc_tt_J2P_tj:78' t32 = -t19;
    // 'kin_xyzbc_tt_J2P_tj:79' t33 = -t22;
    // 'kin_xyzbc_tt_J2P_tj:80' t34 = -t29;
    // 'kin_xyzbc_tt_J2P_tj:81' t35 = -t30;
    // 'kin_xyzbc_tt_J2P_tj:82' t39 = t3.*t37;
    // 'kin_xyzbc_tt_J2P_tj:83' t40 = t5.*t37;
    // 'kin_xyzbc_tt_J2P_tj:84' t41 = t23+t26;
    t41 = t23 + in2[4] * t3 * t4;
    // 'kin_xyzbc_tt_J2P_tj:85' t42 = t24+t25;
    t42_tmp = in2[4] * t2;
    t42 = t24 + t42_tmp * t5;
    // 'kin_xyzbc_tt_J2P_tj:86' t43 = t4.*t5.*t38;
    // 'kin_xyzbc_tt_J2P_tj:87' t45 = t2.*t3.*t36;
    t45_tmp = t2 * t3;
    t45 = t45_tmp * t36;
    // 'kin_xyzbc_tt_J2P_tj:88' t46 = t2.*t3.*t38;
    // 'kin_xyzbc_tt_J2P_tj:89' t47 = t2.*t5.*t36;
    // 'kin_xyzbc_tt_J2P_tj:90' t48 = t3.*t4.*t36;
    // 'kin_xyzbc_tt_J2P_tj:91' t49 = t2.*t5.*t38;
    // 'kin_xyzbc_tt_J2P_tj:92' t50 = t3.*t4.*t38;
    t50_tmp = t3 * t4;
    t50 = t50_tmp * t38;
    // 'kin_xyzbc_tt_J2P_tj:93' t51 = t4.*t5.*t36;
    // 'kin_xyzbc_tt_J2P_tj:94' t44 = -t40;
    // 'kin_xyzbc_tt_J2P_tj:95' t52 = t17+t35;
    t52 = t17 + -(in2[4] * t4 * t5);
    // 'kin_xyzbc_tt_J2P_tj:96' t53 = t18+t34;
    t53 = t42_tmp * t3 + -t29;
    // 'kin_xyzbc_tt_J2P_tj:97' t54 = -t45;
    // 'kin_xyzbc_tt_J2P_tj:98' t55 = -t47;
    // 'kin_xyzbc_tt_J2P_tj:99' t56 = -t50;
    // 'kin_xyzbc_tt_J2P_tj:100' t57 = t46+t48;
    t57 = t45_tmp * t38 + t50_tmp * t36;
    // 'kin_xyzbc_tt_J2P_tj:101' t58 = t49+t51;
    t58_tmp = t4 * t5;
    b_t58_tmp = t2 * t5;
    t58 = b_t58_tmp * t38 + t58_tmp * t36;
    // 'kin_xyzbc_tt_J2P_tj:102' t59 = jp4.*t58;
    t59 = in2[3] * t58;
    // 'kin_xyzbc_tt_J2P_tj:103' t60 = jp5.*t58;
    // 'kin_xyzbc_tt_J2P_tj:104' t61 = t45+t56;
    t61 = t45 + -t50;
    // 'kin_xyzbc_tt_J2P_tj:105' t62 = t43+t55;
    t62 = t58_tmp * t38 + -(b_t58_tmp * t36);
    // 'kin_xyzbc_tt_J2P_tj:106' t63 = jp4.*t57;
    t63 = in2[3] * t57;
    // 'kin_xyzbc_tt_J2P_tj:107' t64 = jp5.*t57;
    // 'kin_xyzbc_tt_J2P_tj:108' t70 = t8+t11+t44+t50+t54;
    t70 = (((in4[9] * t3 + in4[10] * t5) + -(t5 * t37)) + t50) + -t45;
    // 'kin_xyzbc_tt_J2P_tj:109' t65 = jp4.*t62;
    // 'kin_xyzbc_tt_J2P_tj:110' t66 = -t60;
    // 'kin_xyzbc_tt_J2P_tj:111' t67 = jp4.*t61;
    // 'kin_xyzbc_tt_J2P_tj:112' t68 = -t63;
    // 'kin_xyzbc_tt_J2P_tj:113' t71 = t10+t31+t39+t62;
    t71 = ((in4[9] * t5 + -(in4[10] * t3)) + t3 * t37) + t62;
    // 'kin_xyzbc_tt_J2P_tj:114' t69 = -t65;
    // 'kin_xyzbc_tt_J2P_tj:115' t72 = t16+t20+t66+t67;
    t72_tmp = in2[2] * t2;
    t72 = ((t72_tmp * t3 + in2[0] * t3 * t4) + -(in2[4] * t58)) + in2[3] * t61;
    // 'kin_xyzbc_tt_J2P_tj:116' t73 = t21+t27+t64+t69;
    t73_tmp = in2[0] * t4;
    t73 = ((t72_tmp * t5 + t73_tmp * t5) + in2[4] * t57) + -(in2[3] * t62);
    // 'kin_xyzbc_tt_J2P_tj:117' mt1 =
    // [jp5.*t29.*2.0-jpp4.*t3.*t4-jpp5.*t2.*t5-t2.*t3.*t6-t2.*t3.*t7,jp5.*t24.*2.0-jpp5.*t2.*t3+jpp4.*t4.*t5+t2.*t5.*t6+t2.*t5.*t7,jpp4.*t2-t4.*t6,0.0,0.0,jpp5.*t3-t5.*t7,-jpp5.*t5-t3.*t7,0.0,0.0,0.0,jp5.*t23.*2.0-jpp4.*t2.*t3+jpp5.*t4.*t5+t3.*t4.*t6+t3.*t4.*t7,jp5.*t17.*2.0+jpp4.*t2.*t5+jpp5.*t3.*t4-t4.*t5.*t6-t4.*t5.*t7,-jpp4.*t4-t2.*t6,0.0,0.0,-jp4.*(t15-t22+t68+jp5.*t62)+jp3.*t42-jp1.*t52+jp5.*t73+jpp5.*t58-jpp4.*t61-jpp1.*t3.*t4-jpp3.*t2.*t3];
    // 'kin_xyzbc_tt_J2P_tj:118' mt2 =
    // [jp1.*t41+jp3.*t53+jp5.*t72+jpp5.*t57-jpp4.*t62+jp4.*(t19-t28-t59+jp5.*t61)+jpp1.*t4.*t5+jpp3.*t2.*t5,jpp1.*t2-jpp3.*t4-jp4.*(jp1.*t4+jp3.*t2+jp4.*(t2.*t36-t4.*t38))-jpp4.*(t2.*t38+t4.*t36)-jp1.*jp4.*t4-jp3.*jp4.*t2,0.0,0.0,-jp5.*(t15+t33+t68+jp2.*t5+jp5.*t71)+jp3.*t41-jp1.*t53+jp4.*t73+jpp2.*t3+jpp4.*t58+jpp5.*t70-jp2.*jp5.*t5-jpp1.*t2.*t5+jpp3.*t4.*t5];
    // 'kin_xyzbc_tt_J2P_tj:119' mt3 =
    // [-jp5.*(t28+t32+t59+jp2.*t3+jp5.*t70)+jp1.*t42+jp3.*t52+jp4.*t72-jpp2.*t5+jpp4.*t57-jpp5.*t71-jp2.*jp5.*t3-jpp1.*t2.*t3+jpp3.*t3.*t4,0.0,0.0,0.0];
    // 'kin_xyzbc_tt_J2P_tj:120' J2P_tj = reshape([mt1,mt2,mt3],5,5);
    in2_tmp = in3[4] * t2;
    b_in2[0] =
        (((in2[4] * t29 * 2.0 - in3[3] * t3 * t4) - in2_tmp * t5) - t45_tmp * t6) - t45_tmp * t7;
    b_in2[1] = (((in2[4] * t24 * 2.0 - in2_tmp * t3) + in3[3] * t4 * t5) + b_t58_tmp * t6) +
               b_t58_tmp * t7;
    b_in2_tmp = in3[3] * t2;
    b_in2[2] = b_in2_tmp - t4 * t6;
    b_in2[3] = 0.0;
    b_in2[4] = 0.0;
    c_in2_tmp = in3[4] * t3;
    b_in2[5] = c_in2_tmp - t5 * t7;
    b_in2[6] = -in3[4] * t5 - t3 * t7;
    b_in2[7] = 0.0;
    b_in2[8] = 0.0;
    b_in2[9] = 0.0;
    b_in2[10] =
        (((in2[4] * t23 * 2.0 - b_in2_tmp * t3) + in3[4] * t4 * t5) + t50_tmp * t6) + t50_tmp * t7;
    b_in2[11] =
        (((in2[4] * t17 * 2.0 + b_in2_tmp * t5) + c_in2_tmp * t4) - t58_tmp * t6) - t58_tmp * t7;
    b_in2[12] = -in3[3] * t4 - t2 * t6;
    b_in2[13] = 0.0;
    b_in2[14] = 0.0;
    d_in2_tmp = in3[2] * t2;
    b_in2[15] =
        ((((((-in2[3] * (((t15 - t22) + -t63) + in2[4] * t62) + in2[2] * t42) - in2[0] * t52) +
            in2[4] * t73) +
           in3[4] * t58) -
          in3[3] * t61) -
         in3[0] * t3 * t4) -
        d_in2_tmp * t3;
    b_in2[16] = ((((((in2[0] * t41 + in2[2] * t53) + in2[4] * t72) + in3[4] * t57) - in3[3] * t62) +
                  in2[3] * (((t19 - t28) - t59) + in2[4] * t61)) +
                 in3[0] * t4 * t5) +
                d_in2_tmp * t5;
    e_in2_tmp = in3[0] * t2;
    f_in2_tmp = in3[2] * t4;
    b_in2[17] = ((((e_in2_tmp - f_in2_tmp) -
                   in2[3] * ((t73_tmp + t72_tmp) + in2[3] * (t2 * t36 - t4 * t38))) -
                  in3[3] * (t2 * t38 + t4 * t36)) -
                 in2[0] * in2[3] * t4) -
                in2[2] * in2[3] * t2;
    b_in2[18] = 0.0;
    b_in2[19] = 0.0;
    g_in2_tmp = in2[1] * in2[4];
    b_in2[20] =
        ((((((((-in2[4] * ((((t15 + -t22) + -t63) + in2[1] * t5) + in2[4] * t71) + in2[2] * t41) -
               in2[0] * t53) +
              in2[3] * t73) +
             in3[1] * t3) +
            in3[3] * t58) +
           in3[4] * t70) -
          g_in2_tmp * t5) -
         e_in2_tmp * t5) +
        f_in2_tmp * t5;
    b_in2[21] =
        ((((((((-in2[4] * ((((t28 + -t19) + t59) + in2[1] * t3) + in2[4] * t70) + in2[0] * t42) +
               in2[2] * t52) +
              in2[3] * t72) -
             in3[1] * t5) +
            in3[3] * t57) -
           in3[4] * t71) -
          g_in2_tmp * t3) -
         e_in2_tmp * t3) +
        in3[2] * t3 * t4;
    b_in2[22] = 0.0;
    b_in2[23] = 0.0;
    b_in2[24] = 0.0;
    for (int i{0}; i < 5; i++) {
        for (int i1{0}; i1 < 5; i1++) {
            J2P_tj[i][i1] = b_in2[i1 + 5 * i];
        }
    }
}

} // namespace ocn

//
// File trailer for kin_xyzbc_tt_J2P_tj.cpp
//
// [EOF]
//
